#define configDir "/etc/letronik/lin4leic.conf"
#define comlogDir "/val/log/letronik/comlog.txt"
#define demon 0  //1 program niemowa, 0 program wypisuje na konsoli.
#define programName "lin4leic024-03"



/*
ISC License (ISCL)

Copyright (c) 2010.  Leszek Loboda - Zakład Elektroniczny Letronik.
Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies.
THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/



/*

024 - ukrywanie sekund w raportach dla recordtime>60
wstepne przygotowywanie linii raportu

021 - praca cicha. - 
lin4leic020
obsluga sygnalu ctrl-c
wprowadzenie pliku serwisowego miesiecznego lei4leic201004.txt

lincom16 - zmiana polozenia pliku configuracyjnego

lincom15 wylaczanie logu comlog.txt

Programm lincom do obslugi licznikow LEIC4650 firmy letronik.
lincom14
nowy format informacji o braku transmisji.
lincom13
podzial pliku programu
liczenie awarii F

lincom012
wyswietla rectimeint - moze zrobic liczenie F?
lincom011 wykrywa F, werjsa testowa z pelnym wydrukiem
lincom010 prawidlowo zamienia bufor na int
lincom007 wycina liczby z bufora, nie wykrywa F
lincomconf005
wyciaganie zmiennych z coma
20100413 linComConf003
comlog.txt

20100412

proceduta wpisywania godziny
plik konfigruacyjny lincom.conf

20100411 linCom.
wersja jendonwatkowa
*20050218
*20040804 ic4600f-1 - zamienilem ostatni zbedny znak na spacji i sredik na przecinek.
*logerr1200-0.0.2.c
*sprobojemy urodzic jeszcze jeden proses potomny
*logerr1200-0.0.1.c
*wsyla 10 razy znak r
*B1200
 *  AUTHOR: Sven Goldt (goldt@math.tu-berlin.de)
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
*/
/*
 This is like all programs in the Linux Programmer's Guide meant
 as a simple practical demonstration.
 It can be used as a base for a real terminal program.
*/
#include <stdlib.h>
#include <termios.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include "ll4650lib.c"
#include "leszekllib.c"




int runInt=1;//kontynuuj dzialanie jesli 1


void waitN(int n)
{
while((gettimesec() % n != 0) && runInt)
{
sleep(1);
}
}

void zlapalem()//obsluga sygnalu ctrl-c
{
runInt=0;


 //fflush(stdout);

}

//MAIN()-------------------------------------------------------------------------
main()
{
char filename[250],filenameO[250],logname[100],tempchar[50],recline[255];
char checksumChar[10];
int fd,j,n=0,nRec,m,num=0,numold=0;
int rectimint;//odstep rekordow

//nRec - ilosc recordow
int res;//rezultat odczytu
int bladF=0;//ilosc bledow fotokomorki
int bladC=0;//ilosc bledow komunikacji
unsigned int c;//bufor znaku;
char godzina[10];
char godzinaV[10];//godzina z lub bez sekund
char dateday[40];
char MODEMDEVICE[80],rectim[10],yeslog[6],yesconsole[6];
char ch;
char blady[50];//bufor tekstu bledow 
char buf[255];//bufor znakow
char anum[10];//bufor liczby
//char fconfig[100];//nazwa pliku configuracji
FILE *flog,*fcom,*frec, *fopen();
struct termios oldtio,newtio,oldstdtio,newstdtio,oldout;
//struct sigaction sa,sak;

signal(SIGINT, zlapalem);
signal(SIGTERM, zlapalem);


{
//nie mozna zapisac do logu przed oczytem konfiguracji - nazwy jpliku logu
//log serwisowy
strcpy(logname,"/var/log/letronik/lin4leic");
getdate('0',dateday);
strncat(logname,dateday,6);
strcat(logname,".log");

gettime(godzina);
flog=fopen(logname,"a");
getdate('-',dateday);
fprintf(flog,"\nSTART %s - %s\n",dateday, godzina);
fclose(flog);
}



//getdate('0',dateday);
//printf("\n%s\n",dateday);
//getdate('+',dateday);
//printf("\n%s\n",dateday);
///getdate(':',dateday);
//printf("\n%s\n",dateday);

//printf("Program reaguje na klwiature, sam odpytuje licznik co 20 sekund.\r\n");
//printf("Program podaje czas i zliczenie \n\r");
//printf("Program dopisuje dane do pliku ic4600.csv w katalogu wywolania \n\n\r");


//----------czytanie pliku konfiguracyjnego-------------------
if (confRead(configDir,"portname", MODEMDEVICE)>= 0)
if (confRead(configDir,"recordtime", rectim)>= 0)
if (confRead(configDir,"entry", filenameO)>= 0)
if (confRead(configDir,"comlog", yeslog)>= 0)
//if (confRead(configDir,"console", yesconsole)>= 0)
{//jest konfiguracja
//yesconsole[0]='y';//bez wypisywania na konsoli.



rectimint=atoi(rectim); //odtwarzanie odstepu rekordow
if(rectimint<2) rectimint=2;

//printf("nazwa raportu = %s\n",filenameO);
gettime(godzina);
getdate('0',dateday);
strcpy(filename,"/var/log/letronik/");
strcat(filename,filenameO);
strcat(filename,"_");
strcat(filename,dateday);
strcat(filename,".csv");
//strcat(filename,"_");
//strncat(filename,godzina,2);
if(!demon)
{

printf("\nProgram do komunikacji z licznikami LEIC-4650\n");
printf("Aby zakonczyc wcisnij ctrl-c \n");
printf("wersja =  %s  \nCOM = %s\nOdstep rekordow = % d sek.\n",programName, MODEMDEVICE,rectimint);
printf("nazwa logg serwisowy = %s\n",logname);
printf("nazwa raportu = %s\n",filename);
if(yeslog[0]=='y')
printf("comlog yes\n");
else
printf("comlog no\n");


//if(yesconsole[0]=='y')
printf("console yes\n");
//else
//printf("console no\n");
}





/* 
  Open modem device for reading and writing and not as controlling tty
  because we don't want to get killed if linenoise sends CTRL-C.
*/

#define BAUDRATE B1200
//#define MODEMDEVICE "/dev/ttyUSB0"
//#define ENDMINITERM 2 /* ctrl-b to quit miniterm */

//#define _POSIX_SOURCE 1 /* POSIX compliant source */
 fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY);
 if (fd <0) 
 {
strcpy(tempchar,"Blad otwarcia portu");
 perror(MODEMDEVICE);
  exit(-1); 
  }
else
strcpy(tempchar,"Otwarto port ");

if(!demon)
printf("\n\n%s %s\n\n",tempchar,MODEMDEVICE);

flog=fopen(logname,"a");

fprintf(flog,"%s - %s\n",tempchar,MODEMDEVICE);
fclose(flog);
 
 tcgetattr(fd,&oldtio); /* save current modem settings */
 //bzero(&newtio, sizeof(newtio));//wyczysc strukture ustawienia portu

/* 
  Set bps rate and hardware flow control and 8n1 (8bit,no parity,1 stopbit).
  Also don't hangup automatically and ignore modem status.
  Finally enable receiving characters.
*/
// newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
newtio.c_cflag &= ~PARENB;
newtio.c_cflag &= ~PARODD;
newtio.c_cflag &= ~CSTOPB; 
/*
 Ignore bytes with parity errors and make terminal raw and dumb.
*/
 newtio.c_iflag = IGNPAR;
 
/*
 Raw output.
*/
 newtio.c_oflag = 0;
 
/*
 Don't echo characters because if you connect to a host it or your
 modem will echo characters for you. Don't generate signals.
*/
 newtio.c_lflag = 0;
 
/* blocking read until 1 char arrives */
 newtio.c_cc[VMIN]=0;
 newtio.c_cc[VTIME]=0;
 
/* now clean the modem line and activate the settings for modem */
 tcflush(fd, TCIFLUSH);
 tcsetattr(fd,TCSANOW,&newtio);








while(runInt)//petla glowniejsza 

{//petla glowna-------------------------------------------

c='r';

//printf("\nprzed write");
gettime(godzina);//dorobic formatowanie godziny
if(rectimint>=60)
{
strncpy(godzinaV,godzina,5);//bez sekund
godzinaV[5]=0;
}
else
strcpy(godzinaV,godzina);// z sekundami
//printf("%s\n",godzinaV);
getdate('-',dateday);
write(fd,&c,1);//wysylanie zapytania do licznika
sleep(1);//odczekanie
//printf("Xza write\n");
res = read(fd,buf,255);//odczytanie natychmiastowe bufora
//printf("Xza read\n");
if (res>0)//jesli odebrano znaki
{
buf[res]=0;
m=getdata(buf, &num,&bladF);
numold=num;
if(bladF)
strcpy(blady,"blad fotokomorki");
else
strcpy(blady," ");
bladC=0;
//if(!demon)
//sprintf(recline,"%s;%6d;%02d;00",godzinaV,num,bladF);
//putchar(blad);
if(yeslog[0]=='y')
{
fcom=fopen(comlogDir,"a");
fprintf(fcom,"%s",buf);
fclose(fcom);
}
}//jesli odebrano znaki
else
bladC=1;//brak konumikacji

sprintf(recline,"%s;%6d;%2d;%2d;",godzinaV,numold,bladF,bladC);
sprintf(checksumChar,"0X%04X",checksumll(recline));

if(!demon)
printf("%s%s\n", recline,checksumChar);

{
getdate('0',dateday);
strcpy(filename,"/var/log/letronik/");
strcat(filename,filenameO);
strcat(filename,"_");
strcat(filename,dateday);
strcat(filename,".csv");
//strcat(filename,"_");
//strncat(filename,godzina,2);
frec=fopen(filename,"a");

fprintf(frec,"%s%s\n", recline,checksumChar);
fclose(frec);
}
waitN(rectimint);
}//petla glowna

}//jest konfiguracja
if(!demon)
printf("KONIEC\n");
{
gettime(godzina);
getdate('-',dateday);
flog=fopen(logname,"a");
getdate('-',dateday);
fprintf(flog,"STOP %s - %s\n",dateday, godzina);
fclose(flog);
}


}
